"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const devkit_1 = require("@nrwl/devkit");
const camelcase_1 = require("camelcase");
const dashify = require("dashify");
const path = require("path");
const to_uppercase_1 = require("../util/to-uppercase");
async function default_1(tree, schema) {
    var _a, _b, _c;
    console.log('command generator running for: ', schema.name);
    const { name: commandName, serviceName, outputDirectory, getItem } = schema;
    const typedGetItem = getItem;
    console.log('typedGetItem.parameters: ', typedGetItem.operationObj.parameters, typedGetItem.commonParameters);
    const params = [
        ...((_b = (_a = typedGetItem.operationObj.parameters) === null || _a === void 0 ? void 0 : _a.filter(param => param.in === 'path')) !== null && _b !== void 0 ? _b : []),
        ...((_c = typedGetItem.commonParameters) !== null && _c !== void 0 ? _c : []),
    ];
    console.log('params combined: ', params);
    (0, devkit_1.generateFiles)(tree, path.join(__dirname, 'files'), outputDirectory, {
        name: commandName,
        path: typedGetItem.path,
        namePascal: (0, camelcase_1.default)(commandName, { pascalCase: true }),
        nameDash: dashify(commandName),
        nameCamel: (0, camelcase_1.default)(commandName),
        uppercase: to_uppercase_1.uppercase,
        camelCase: camelcase_1.default,
        serviceNamePascal: (0, camelcase_1.default)(serviceName, { pascalCase: true }),
        serviceNameCamel: (0, camelcase_1.default)(serviceName),
        serviceNameDash: dashify(serviceName),
        parameters: params,
    });
    await (0, devkit_1.formatFiles)(tree);
    // TODO add export to index.ts commands
    const commandsIndexFile = tree.read(`${outputDirectory}/src/commands/index.ts`);
    console.log('tree: ', commandsIndexFile === null || commandsIndexFile === void 0 ? void 0 : commandsIndexFile.toString());
    if (commandsIndexFile) {
        // const newContents = tsquery.ast(commandsIndexFile?.toString());
        // const exportDeclaration = ts.factory.createExportDeclaration(
        //     undefined,
        //     false,
        //     ,
        //     ts.factory.createStringLiteral('test', true)
        // );
        //
        // const printer = ts.createPrinter({ newLine: ts.NewLineKind.LineFeed });
        //
        // const temp = printer.printNode(ts.EmitHint.Unspecified, exportDeclaration, newContents);
        // console.log('thing: ', temp);
    }
    // const fileEntry = tree.read(filePath);
    // const contents = fileEntry.toString();
    //
    // // Check each `TypeReference` node to see if we need to replace it
    // const newContents = tsquery.replace(contents, 'TypeReference', node => {
    //     const trNode = node as TypeReferenceNode;
    //     if (trNode.typeName.getText() === 'Array') {
    //         const typeArgument = trNode.typeArguments[0];
    //         return `${typeArgument.getText()}[]`;
    //     }
    //     // return undefined does not replace anything
    // });
    //
    // // only write the file if something has changed
    // if (newContents !== contents) {
    //     tree.write(filePath, newContents);
    // }
    return () => {
        // installPackagesTask(tree);
    };
}
exports.default = default_1;
